/*
 *      Luis Israel Diéguez Arjona
 *      Sonia Cejas Soria
 *      Sergio Cabello García
 *      María José González Cordero
 *
 *      Ingeniería del Software de Gestión II
 *      Ingeniería Técnica Informática de Gestión
 *      Universidad de Huelva
 */

package vista;

import controlador.Utilidades;
import java.awt.Color;
import java.util.ArrayList;
import java.util.Date;
import java.util.Observable;
import java.util.Observer;
import javax.swing.DefaultListModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.*;





public class jfParticipante extends javax.swing.JFrame implements Observer {
    // Formulario padre
    jfHome home;
    boolean modificado = false;
    // Colores
    Color colorBlanco = new Color(255, 255, 255);
    Color colorAmarillo = new Color(255, 255, 102);
    // Fecha
    Date fecha;
    // Utilidades
    Utilidades utilidades = new Utilidades();
    // JTree
    MutableTreeNode currentNode;
    MutableTreeNode insertNode;
    int insertIndex;
    // Control del Update de Observers
    int vecesActualizo = 0;
    private Participante participante;
    //Crear un arraylist de Organizaciones.
    ArrayList<Organizacion> organizacion = new ArrayList<Organizacion>();
    private DefaultListModel modeloListaAutores;
    private DefaultListModel modeloListaFuentes;

    public jfParticipante() {
        initComponents();
        organizacion = home.documentoRequisitos.getOrganizacion();
    }
    public jfParticipante(jfHome home) {
        // Inicializo
        initComponents();
        this.home = home;
        this.insertNode = home.getInsertNode();
        this.insertIndex = home.getInsertIndex(insertNode);
        // Configura el identificador
        String ident = this.home.documentoRequisitos.getNuevoIdentificadorParticipante();
        this.jTextField_identificacion.setText(ident);
        // Fecha del sistema
        fecha = new Date();
        jDateChooserFecha.setDate(fecha);

        organizacion = home.documentoRequisitos.getOrganizacion();
        //Relleno el combobox de organizacion.
        for(int i = 0; i < organizacion.size(); i++)
            this.jComboBox_organizacion.addItem(organizacion.get(i).getIdentificacion() + " - " + organizacion.get(i).getNombre());
        
        jTextField_nombre.requestFocus();

    }
    public void inicializarModificacion (Participante participante) {
        modificado = true;
        
        // Pestaña General
        jTextField_identificacion.setText(utilidades.getIdentificadorNumerico(participante.getIdentificacion()));
        jTextField_nombre.setText(participante.getNombre());
        jTextField_nombre.setEditable(false);
        String version = participante.getVersion();
        if (!version.equals(".")) {
            String versIzq = version.substring(0, version.indexOf("."));
            String versDer = version.substring(version.indexOf(".")+1, version.length());
            jTextField_versionIzq.setText(versIzq);
            jTextField_versionDer.setText(versDer);
        }
        jDateChooserFecha.setDate(participante.getFecha());

        //Autores y fuentes
        //Obtengo mi lista de autores.
        ArrayList<Participante> autores = participante.getAutores();
        ArrayList<String> miArrayAutor = new ArrayList<String>();
        for (int j=0; j<autores.size(); j++)
            miArrayAutor.add("(" + autores.get(j).getIdentificacion() + ") " + autores.get(j).getNombre());
        utilidades.setArrayAutor(miArrayAutor);

        //Obtengo mi lista de fuentes.
        ArrayList<Participante> fuentes = participante.getFuentes();
        ArrayList<String> miArrayFuentes = new ArrayList<String>();
        for (int j=0; j<fuentes.size(); j++)
            miArrayFuentes.add("(" + fuentes.get(j).getIdentificacion() + ") " + fuentes.get(j).getNombre());
        utilidades.setArrayFuente(miArrayFuentes);
        
        
        // Pestaña Detalle
        jTextField_rol.setText(participante.getRol());
        if(participante.getOrganizacion()!=null)
            jComboBox_organizacion.setSelectedItem(participante.getOrganizacion().getIdentificacion() + " - " + participante.getOrganizacion().getNombre());
        
        if (participante.getEsCliente())
            jCheckBox_esCliente.setSelected(true);
        if (participante.getEsDesarrollador())
            jCheckBox_esDesarrollador.setSelected(true);
        if (participante.getEsUsuario())
            jCheckBox_esUsuario.setSelected(true);

        // Pestaña Comentarios
        jTextArea_comentarios.setText(participante.getComentario());
    }





    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jLabel_identificador = new javax.swing.JLabel();
        jTextField_identificacion = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField_nombre = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTextField_versionIzq = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField_versionDer = new javax.swing.JTextField();
        jDateChooserFecha = new com.toedter.calendar.JDateChooser();
        jPanel10 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList_autores = new javax.swing.JList();
        jButton_anadirAutor = new javax.swing.JButton();
        jButton_eliminarAutor = new javax.swing.JButton();
        jPanel11 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList_fuentes = new javax.swing.JList();
        jButton_eliminarFuente = new javax.swing.JButton();
        jButton_anadirFuente = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jPanel12 = new javax.swing.JPanel();
        jCheckBox_esCliente = new javax.swing.JCheckBox();
        jCheckBox_esDesarrollador = new javax.swing.JCheckBox();
        jCheckBox_esUsuario = new javax.swing.JCheckBox();
        jPanel13 = new javax.swing.JPanel();
        jComboBox_organizacion = new javax.swing.JComboBox();
        jPanel14 = new javax.swing.JPanel();
        jTextField_rol = new javax.swing.JTextField();
        jPanel7 = new javax.swing.JPanel();
        jPanel23 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextArea_comentarios = new javax.swing.JTextArea();
        jButton_aceptar = new javax.swing.JButton();
        jButton_cancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Participante");
        setAlwaysOnTop(true);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jPanel1.setPreferredSize(new java.awt.Dimension(563, 306));

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(564, 262));

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Identificación"));
        jPanel8.setToolTipText("");
        jPanel8.setName(""); // NOI18N

        jLabel_identificador.setText("STK-");

        jTextField_identificacion.setEditable(false);
        jTextField_identificacion.setMinimumSize(new java.awt.Dimension(6, 15));
        jTextField_identificacion.setPreferredSize(new java.awt.Dimension(35, 20));

        jLabel2.setText("Nombre:");

        jTextField_nombre.setPreferredSize(new java.awt.Dimension(300, 20));

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel_identificador)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField_identificacion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 101, Short.MAX_VALUE)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField_nombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel_identificador)
                .addComponent(jTextField_identificacion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel2)
                .addComponent(jTextField_nombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Versión"));
        jPanel9.setPreferredSize(new java.awt.Dimension(525, 43));

        jLabel3.setText("Número:");

        jLabel4.setText("Fecha:");

        jTextField_versionIzq.setText("1");
        jTextField_versionIzq.setPreferredSize(new java.awt.Dimension(20, 20));

        jLabel5.setText(".");

        jTextField_versionDer.setText("0");
        jTextField_versionDer.setPreferredSize(new java.awt.Dimension(20, 20));

        jDateChooserFecha.setDateFormatString("dd/MM/yyyy");

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField_versionIzq, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField_versionDer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(68, 68, 68)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jDateChooserFecha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(222, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel3)
                        .addComponent(jTextField_versionIzq, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel5)
                        .addComponent(jTextField_versionDer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel4))
                    .addComponent(jDateChooserFecha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder("Autores"));
        jPanel10.setPreferredSize(new java.awt.Dimension(265, 114));

        jList_autores.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(jList_autores);

        jButton_anadirAutor.setText("Añadir");
        jButton_anadirAutor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_anadirAutorActionPerformed(evt);
            }
        });

        jButton_eliminarAutor.setText("Eliminar");
        jButton_eliminarAutor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_eliminarAutorActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 233, Short.MAX_VALUE)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addComponent(jButton_anadirAutor)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_eliminarAutor)))
                .addContainerGap())
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_eliminarAutor)
                    .addComponent(jButton_anadirAutor))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder("Fuentes"));
        jPanel11.setPreferredSize(new java.awt.Dimension(265, 78));

        jList_fuentes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane2.setViewportView(jList_fuentes);

        jButton_eliminarFuente.setText("Eliminar");
        jButton_eliminarFuente.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_eliminarFuenteActionPerformed(evt);
            }
        });

        jButton_anadirFuente.setText("Añadir");
        jButton_anadirFuente.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_anadirFuenteActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 233, Short.MAX_VALUE)
                    .addGroup(jPanel11Layout.createSequentialGroup()
                        .addComponent(jButton_anadirFuente)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_eliminarFuente)))
                .addContainerGap())
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButton_anadirFuente, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton_eliminarFuente, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, 543, Short.MAX_VALUE)
                    .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 13, Short.MAX_VALUE)
                        .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel11, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                    .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("General", jPanel2);

        jPanel12.setBorder(javax.swing.BorderFactory.createTitledBorder("Tipo de participante"));

        jCheckBox_esCliente.setText("El participante es un cliente");

        jCheckBox_esDesarrollador.setText("El participante es un desarrollador");

        jCheckBox_esUsuario.setText("El participante es un usuario");

        javax.swing.GroupLayout jPanel12Layout = new javax.swing.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBox_esCliente)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBox_esDesarrollador)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox_esUsuario)
                .addContainerGap(16, Short.MAX_VALUE))
        );
        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBox_esCliente)
                    .addComponent(jCheckBox_esDesarrollador)
                    .addComponent(jCheckBox_esUsuario))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jPanel13.setBorder(javax.swing.BorderFactory.createTitledBorder("Organización"));

        jComboBox_organizacion.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--" }));

        javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addComponent(jComboBox_organizacion, javax.swing.GroupLayout.PREFERRED_SIZE, 479, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addComponent(jComboBox_organizacion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder("Rol"));

        javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jTextField_rol, javax.swing.GroupLayout.PREFERRED_SIZE, 481, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(26, Short.MAX_VALUE))
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addComponent(jTextField_rol, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel14, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(37, 37, 37))
        );

        jTabbedPane1.addTab("Detalle", jPanel3);

        jPanel23.setBorder(javax.swing.BorderFactory.createTitledBorder("Comentarios"));

        jTextArea_comentarios.setColumns(20);
        jTextArea_comentarios.setLineWrap(true);
        jTextArea_comentarios.setRows(5);
        jScrollPane6.setViewportView(jTextArea_comentarios);

        javax.swing.GroupLayout jPanel23Layout = new javax.swing.GroupLayout(jPanel23);
        jPanel23.setLayout(jPanel23Layout);
        jPanel23Layout.setHorizontalGroup(
            jPanel23Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel23Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 511, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel23Layout.setVerticalGroup(
            jPanel23Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel23Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel23, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel23, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("Comentarios", jPanel7);

        jButton_aceptar.setText("Aceptar");
        jButton_aceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_aceptarActionPerformed(evt);
            }
        });

        jButton_cancelar.setText("Cancelar");
        jButton_cancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_cancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 568, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(406, Short.MAX_VALUE)
                .addComponent(jButton_aceptar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton_cancelar)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_cancelar)
                    .addComponent(jButton_aceptar))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 568, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 295, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton_cancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_cancelarActionPerformed
        home.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jButton_cancelarActionPerformed
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        home.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed
    private void jButton_aceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_aceptarActionPerformed
        participante = new Participante();
        boolean puedoCerrar = true;

        // Identificador
        participante.setIdentificacion(this.jLabel_identificador.getText() + this.jTextField_identificacion.getText());

        // Nombre
        if (!this.jTextField_nombre.getText().equals("")) {
            this.jTextField_nombre.setBackground(colorBlanco);
            participante.setNombre(this.jTextField_nombre.getText());
        } else {
            this.jTextField_nombre.setBackground(colorAmarillo);
            puedoCerrar = false;
        }
        
        participante.setVersion(this.jTextField_versionIzq.getText() + "." + this.jTextField_versionDer.getText());
        
        // Autores
        ArrayList<String> listaAutores = utilidades.getArrayAutor();

        if (!listaAutores.isEmpty()) {                                                  // SI hay autores en el formulario
            ArrayList<Participante> autores = new ArrayList<Participante>();

            for (int i = 0; i < listaAutores.size(); i++) {                              // Recorro cada autor del formulario
                ArrayList<Participante> participantes = home.documentoRequisitos.getParticipante();              // Obtengo los participantes ya introducidos en el documento requisitos
                String elemento = listaAutores.get(i);
                // Busco el autor introducido en el formulario entre los participantes ya incluídos en el documento
                for (int j = 0; j < participantes.size(); j++) {                                            // Recorro los partipantes del documento
                    if(participantes.get(j).getIdentificacion().equals(elemento.substring(1, 9))){
                        autores.add(participantes.get(j));
                        break;
                    }
                }
            }
            participante.setAutores(autores);
        }

        // Fuentes
        ArrayList<String> listaFuentes = utilidades.getArrayFuente();

        if (!listaFuentes.isEmpty()) {                                                  // SI hay autores en el formulario
            ArrayList<Participante> fuentes = new ArrayList<Participante>();

            for (int i = 0; i < listaFuentes.size(); i++) {                              // Recorro cada autor del formulario
                ArrayList<Participante> participantes = home.documentoRequisitos.getParticipante();              // Obtengo los participantes ya introducidos en el documento requisitos
                String elemento = listaFuentes.get(i);
                // Busco el autor introducido en el formulario entre los participantes ya incluídos en el documento
                for (int j = 0; j < participantes.size(); j++) {                                            // Recorro los partipantes del documento
                    if(participantes.get(j).getIdentificacion().equals(elemento.substring(1, 9))){
                        fuentes.add(participantes.get(j));
                        break;
                    }
                }
            }
            participante.setFuentes(fuentes);
        }

        participante.setRol(this.jTextField_rol.getText());
      

        //Auxiliar para almacenar en participante.
        Organizacion org = new Organizacion();
        //Recorrer el array de organizacion y buscar cual es el que tenemos que almacenar.
        boolean encontrado = false;
        int i = 0;
        organizacion = home.documentoRequisitos.getOrganizacion();
        while(!encontrado && i < organizacion.size())
        {
            String id = organizacion.get(i).getIdentificacion() + " - " + organizacion.get(i).getNombre();

            if(id.equals(this.jComboBox_organizacion.getSelectedItem().toString())){
                participante.setOrganizacion(organizacion.get(i));
                encontrado = true;
            }
            i++;
        }
        if(!encontrado)
            participante.setOrganizacion(org);

         
        participante.setEsCliente(this.jCheckBox_esCliente.isSelected());
        participante.setEsDesarrollador(this.jCheckBox_esDesarrollador.isSelected());
        participante.setEsUsuario(this.jCheckBox_esUsuario.isSelected());

        //Insertamos la fecha.
        fecha = jDateChooserFecha.getDate();
        if(fecha == null)
            fecha = new Date(); //sino metemos ninguna fecha que se guarde la del sistema
        participante.setFecha(fecha);

        // Trazas origen
        // Trazas destino

        participante.setComentario(this.jTextArea_comentarios.getText());

        // Fin de la captura de los datos desde el formulario
        if (puedoCerrar) {
            if (modificado)
                home.documentoRequisitos.modifyParticipante(participante);
            else
                home.documentoRequisitos.addParticipante(participante);

            // Cierro la ventana
            home.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jButton_aceptarActionPerformed

    private void jButton_anadirAutorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_anadirAutorActionPerformed
        // Creo ventana
        jfAddAutor jfAddAutor = new jfAddAutor(home,this, utilidades);
        jfAddAutor.setVisible(true);
        this.setEnabled(false);
        //Centrar ventana
        jfAddAutor.setLocationRelativeTo(this);
        home.documentoRequisitos.addObserver(jfAddAutor);
    }//GEN-LAST:event_jButton_anadirAutorActionPerformed

    private void jButton_eliminarAutorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_eliminarAutorActionPerformed
        if(jList_autores.getSelectedIndex() != -1){ //Si no hay ninguno seleccionado
            utilidades.removeArrayAutor(jList_autores.getSelectedValue().toString());
            modeloListaAutores.remove(jList_autores.getSelectedIndex());
        }
    }//GEN-LAST:event_jButton_eliminarAutorActionPerformed

    private void jButton_anadirFuenteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_anadirFuenteActionPerformed
        // Creo ventana
        jfAddFuente jfAddFuente = new jfAddFuente(home, this, utilidades);
        jfAddFuente.setVisible(true);
        this.setEnabled(false);
        //Centrar ventana
        jfAddFuente.setLocationRelativeTo(this);
        home.documentoRequisitos.addObserver(jfAddFuente);
    }//GEN-LAST:event_jButton_anadirFuenteActionPerformed

    private void jButton_eliminarFuenteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_eliminarFuenteActionPerformed
        if(jList_fuentes.getSelectedIndex() != -1){ //Si no hay ninguno seleccionado
            utilidades.removeArrayFuente(jList_fuentes.getSelectedValue().toString());
            modeloListaFuentes.remove(jList_fuentes.getSelectedIndex());
        }
    }//GEN-LAST:event_jButton_eliminarFuenteActionPerformed

    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        //autores
        modeloListaAutores =   new DefaultListModel();
        jList_autores.setModel(modeloListaAutores);
        ArrayList<String> arrayAutor = utilidades.getArrayAutor();
        for (int i = 0; i < arrayAutor.size(); i++){
            modeloListaAutores.addElement(arrayAutor.get(i));
        }
        
        //fuentes
        modeloListaFuentes = new DefaultListModel();
        jList_fuentes.setModel(modeloListaFuentes);
        ArrayList<String> arrayFuente = utilidades.getArrayFuente();
        for (int i = 0; i < arrayFuente.size(); i++){
            modeloListaFuentes.addElement(arrayFuente.get(i));
        }
    }//GEN-LAST:event_formWindowActivated

    private void actualizarJTree (Participante participante) {
        if(participante != null){
            MutableTreeNode node = new DefaultMutableTreeNode(participante.getNombre() + " (" + participante.getIdentificacion() + ")");
            DefaultTreeModel model = (DefaultTreeModel) home.getJTree().getModel();
            if (modificado == false)
                model.insertNodeInto(node, insertNode, insertIndex);

            // Expande el JTree
            for (int j = 0; j < home.getJTree().getSize().height; j++)
                home.getJTree().expandPath(home.getJTree().getPathForRow(j));
            
            home.getJTree().setSelectionPath(null);
        }
    }




    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new jfParticipante().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton_aceptar;
    private javax.swing.JButton jButton_anadirAutor;
    private javax.swing.JButton jButton_anadirFuente;
    private javax.swing.JButton jButton_cancelar;
    private javax.swing.JButton jButton_eliminarAutor;
    private javax.swing.JButton jButton_eliminarFuente;
    private javax.swing.JCheckBox jCheckBox_esCliente;
    private javax.swing.JCheckBox jCheckBox_esDesarrollador;
    private javax.swing.JCheckBox jCheckBox_esUsuario;
    private javax.swing.JComboBox jComboBox_organizacion;
    private com.toedter.calendar.JDateChooser jDateChooserFecha;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel_identificador;
    private javax.swing.JList jList_autores;
    private javax.swing.JList jList_fuentes;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea_comentarios;
    private javax.swing.JTextField jTextField_identificacion;
    private javax.swing.JTextField jTextField_nombre;
    private javax.swing.JTextField jTextField_rol;
    private javax.swing.JTextField jTextField_versionDer;
    private javax.swing.JTextField jTextField_versionIzq;
    // End of variables declaration//GEN-END:variables

    
    
    

    public void update(Observable o, Object arg) {
        if(vecesActualizo==0){
            actualizarJTree(participante);
            home.actualizarTextPane();
            vecesActualizo++;
        }
    }

}
